﻿package classes {
	import five3D.display.Bitmap3D;
	import five3D.display.Scene3D;
	import five3D.display.Sprite2D;
	import five3D.display.Sprite3D;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import com.hydrotik.go.HydroTween;
	import com.hydrotik.go.HydroSequence;
	import fl.motion.easing.*;

	public class Main extends Sprite {
		
		private var _font1:FontLoader;
		private var _textField:TextFieldCustom;
		private var _scene3D:Scene3D;
		private var _container3D:Sprite3D;
		private var _obj3Ds:Array;
		
		public function Main() {
			stage.scaleMode = "noScale";
            stage.align = "TL";
			
			init();
		}
		
		private function init() {
			_font1 = new FontLoader("font1.swf");
			_font1.addEventListener(FontLoader.FONTLOADCOMPLETE , fontLoadeCompleteFunc ) ;
			_font1.load();
			
			var fps:Fps = new Fps();
			addChild(fps);
		}
		
		private function fontLoadeCompleteFunc(e:Event ):void {
			_font1.registerFont("Font1");
			init3D();
		}
		
		private function init3D():void{
			_scene3D = new Scene3D();
			_scene3D.x = stage.stageWidth / 2 ;
			_scene3D.y = stage.stageHeight / 2 ;
			addChild(_scene3D);
			
			_container3D = new Sprite3D();
			_scene3D.addChild(_container3D);
			//Zソート
			_container3D.childrenSorted = true;
			
			_obj3Ds = [];
			for (var i:int = 0; i < _fighters.length; i++) {
				//テキスト文字列
				var tf:TextFieldCustom = new TextFieldCustom( new  _font1.Font1() , 30);
				tf.setText( _fighters[i] , 0xFFFFFF * Math.random() );
				
				//テキストフィールドにアンチエイリアスかけるとBitmapData.draw不可能？の対処。
				var temp:Sprite = new Sprite();
				temp.addChild( tf );
				
				//テキストをビットマップに変換
				var bmd:BitmapData = new FontBitmap( temp ).bitmapdata;
				
				//3Dにぶち込み。
				var bitmap3D:Bitmap3D = new Bitmap3D(bmd , true );
				bitmap3D.x = -bmd.width / 2;
				bitmap3D.y = -bmd.height / 2;
				
				//Bitmap3D状態だと回転軸の中央寄せができない？？ためSprite3Dにぶち込み。
				var obj3D:Sprite3D = new Sprite3D();
				obj3D.addChild(bitmap3D);
				obj3D.x = stage.stageWidth/2 * Math.random() - stage.stageWidth/2/2;
				obj3D.y = stage.stageHeight / 2 * Math.random() - stage.stageHeight /2/2;
				obj3D.z = 1000 * Math.random() - 500;
				obj3D.addEventListener(MouseEvent.ROLL_OVER , obj3DRollOverFunc );
				
				_container3D.addChild(obj3D);
				
				_obj3Ds.push( obj3D );
			}
			
			_container3D.addEventListener(Event.ENTER_FRAME , _container3DEnterFrameFunc );
			_container3D.rotationX = 15;
			
			stage.addEventListener(Event.RESIZE , _stageResizeFunc );
		}
		
		private function obj3DRollOverFunc(e:MouseEvent):void {
			var target:Sprite3D = e.currentTarget as Sprite3D;
			var rotY:Number = (target.rotationY == 180) ? 0 : 180 ;
			HydroTween.go( target , { rotationY:rotY } , 1 , 0 , Quintic.easeOut )
		}
		
		private function _container3DEnterFrameFunc(e:Event):void {
			//_container3D.rotationX = -_scene3D.mouseY;
			//_container3D.rotationY = _scene3D.mouseX;
			
			_container3D.rotationY += 1;
			//_container3D.rotationZ += (_scene3D.mouseY/2 - _container3D.rotationZ) /20;
		}
		
		private function _stageResizeFunc(e:Event):void {
			_scene3D.x = stage.stageWidth / 2 ;
			_scene3D.y = stage.stageHeight / 2 ;
		}
		
		private var _fighters:Array = [
"Peter Aerts",
"Remy Bonjasky",
//"Bjorn Bregy",
//"F Emelianenko Fedor",
"Glaube Feitosa",
"Badr Hari",
//"Ernesto Hoost",
//"Andy Hug",
//"Mark Hunt",
//"Alexey Ignashov",
//"Attila Karacs",
"Ruslan Karaev",
"Jerome Le Banner",
//"Stefan Blitz Leko",
//"Mighty Mo",
//"Musashi",
//"Gokhan Saki",
//"Zabit Samedov",
//"Bob Sapp",
"Semmy Schilt",
//"Ray Sefo",
//"Paul Slowinski",
//"Ewerton Teixeira",
//"Errol Zimmerman"
];
		
	}
	
}